--- ./cmd/tools/cvtgxl.c_orig	2023-07-03 08:56:15.089319722 +0000
+++ ./cmd/tools/cvtgxl.c	2023-07-03 08:56:22.372675099 +0000
@@ -21,7 +21,7 @@
 #include "config.h"
 
 #include <ctype.h>
-#include <getopt.h>
+//#include <getopt.h>
 #include <stdio.h>
 #include <stdlib.h>
 
--- ./cmd/tools/nop.c_orig	2023-07-03 08:58:17.612363860 +0000
+++ ./cmd/tools/nop.c	2023-07-03 08:58:26.328518201 +0000
@@ -20,7 +20,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 
-#include <getopt.h>
+//#include <getopt.h>
 
 static char **Files;
 static bool chkOnly;
--- ./cmd/tools/bcomps.c_orig	2023-07-03 09:05:58.110762803 +0000
+++ ./cmd/tools/bcomps.c	2023-07-03 09:06:07.598553433 +0000
@@ -25,7 +25,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <assert.h>
-#include <getopt.h>
+//#include <getopt.h>
 
 #include <stdlib.h>
 #include <cgraph/agxbuf.h>
--- ./cmd/tools/gvgen.c_orig	2023-07-03 09:08:05.597459642 +0000
+++ ./cmd/tools/gvgen.c	2023-07-03 09:08:13.502377451 +0000
@@ -24,7 +24,7 @@
 #include <stdlib.h>
 #include <string.h>
 #include <ctype.h>
-#include <getopt.h>
+//#include <getopt.h>
 #include "graph_generator.h"
 #include "openFile.h"
 #include <cgraph/exit.h>
--- ./cmd/tools/gml2gv.c_orig	2023-07-03 09:09:00.868868455 +0000
+++ ./cmd/tools/gml2gv.c	2023-07-03 09:09:14.773840125 +0000
@@ -12,7 +12,7 @@
 #include <stdlib.h>
 #include <string.h>
 
-#include <getopt.h>
+//#include <getopt.h>
 #include <cgraph/agxbuf.h>
 #include <cgraph/alloc.h>
 #include <cgraph/exit.h>
--- ./cmd/tools/gv2gml.c_orig	2023-07-03 09:10:10.303619480 +0000
+++ ./cmd/tools/gv2gml.c	2023-07-03 09:10:19.320106270 +0000
@@ -22,7 +22,7 @@
 #include <string.h>
 #include <inttypes.h>
 
-#include <getopt.h>
+//#include <getopt.h>
 
 #include <cgraph/cgraph.h>
 #include <cgraph/exit.h>
--- ./cmd/gvmap/gvmap.c_orig	2023-07-03 09:12:35.204828626 +0000
+++ ./cmd/gvmap/gvmap.c	2023-07-03 09:12:44.255553818 +0000
@@ -23,7 +23,7 @@
 #include <sparse/QuadTree.h>
 #include <time.h>
 #include <sparse/SparseMatrix.h>
-#include <getopt.h>
+//#include <getopt.h>
 #include <string.h>
 #include "make_map.h"
 #include <sfdpgen/spring_electrical.h>
--- ./cmd/gvmap/cluster.c_orig	2023-07-03 09:13:37.533322796 +0000
+++ ./cmd/gvmap/cluster.c	2023-07-03 09:13:46.414359570 +0000
@@ -17,7 +17,7 @@
 #include <sparse/QuadTree.h>
 #include <time.h>
 #include <sparse/SparseMatrix.h>
-#include <getopt.h>
+//#include <getopt.h>
 #include <string.h>
 #include "make_map.h"
 #include <sfdpgen/spring_electrical.h>
--- ./contrib/prune/prune.c_orig	2023-07-05 04:03:02.417524623 +0000
+++ ./contrib/prune/prune.c	2023-07-05 04:04:23.305007919 +0000
@@ -13,7 +13,7 @@
 #include <string.h>
 #include <ctype.h>
 
-#include <getopt.h>
+//#include <getopt.h>
 #include <cgraph/alloc.h>
 #include <cgraph/cgraph.h>
 #include <cgraph/exit.h>
--- ./cmd/tools/gc.c_orig	2024-03-11 02:16:45.760072488 +0000
+++ ./cmd/tools/gc.c	2024-03-11 02:17:00.895504480 +0000
@@ -37,7 +37,7 @@
 
 #define ND_dfs_mark(n) (((Agnodeinfo_t*)(n->base.data))->dfs_mark)
 
-#include <getopt.h>
+//#include <getopt.h>
 
 #define NODES 1
 #define EDGES 2
--- ./cmd/tools/gvcolor.c_orig	2024-03-11 02:18:12.753397174 +0000
+++ ./cmd/tools/gvcolor.c	2024-03-11 02:18:21.734584533 +0000
@@ -43,7 +43,7 @@
 
 #include <stdio.h>
 
-#include <getopt.h>
+//#include <getopt.h>
 
 double Defcolor[NC] = { 0.0, 0.0, 1.0 };	/* white */
 int Forward = 1;		/* how to propagate colors w.r.t. ranks */
--- ./cmd/tools/acyclic.c_orig	2024-03-11 02:19:19.519358399 +0000
+++ ./cmd/tools/acyclic.c	2024-03-11 02:19:30.350267574 +0000
@@ -31,7 +31,7 @@
 
 #define graphName(g) (agnameof(g))
 
-#include <getopt.h>
+//#include <getopt.h>
 
 static FILE *inFile;
 
--- ./cmd/tools/ccomps.c_orig	2024-03-11 02:20:25.325719607 +0000
+++ ./cmd/tools/ccomps.c	2024-03-11 02:20:34.563385604 +0000
@@ -51,7 +51,7 @@
 #define ND_clust(n)  ((Agraph_t*)ND_ptr(n))
 #define agfindnode(G,N) (agnode(G, N, 0))
 
-#include <getopt.h>
+//#include <getopt.h>
 
 #include <string.h>
 
--- ./cmd/tools/sccmap.c_orig	2024-03-11 02:22:00.507450947 +0000
+++ ./cmd/tools/sccmap.c	2024-03-11 02:22:09.875520435 +0000
@@ -35,7 +35,7 @@
 #include <cgraph/stack.h>
 #include <cgraph/unreachable.h>
 
-#include <getopt.h>
+//#include <getopt.h>
 #include "openFile.h"
 
 #define INF UINT_MAX
--- ./cmd/tools/tred.c_orig	2024-03-11 02:23:01.284144327 +0000
+++ ./cmd/tools/tred.c	2024-03-11 02:23:12.656062662 +0000
@@ -29,7 +29,7 @@
 #include <stdbool.h>
 #include <stdio.h>
 #include <stdlib.h>
-#include <getopt.h>
+//#include <getopt.h>
 
 static char **Files;
 static char *CmdName;
--- ./cmd/tools/unflatten.c_orig	2024-03-11 02:24:22.921435710 +0000
+++ ./cmd/tools/unflatten.c	2024-03-11 02:24:32.430061005 +0000
@@ -27,7 +27,7 @@
 #include    <cgraph/ingraphs.h>
 #include    <cgraph/unreachable.h>
 
-#include <getopt.h>
+//#include <getopt.h>
 #include "openFile.h"
 
 typedef graphviz_unflatten_options_t opts_t;
--- ./cmd/tools/gvpack.cpp_orig	2024-03-11 02:25:37.244922036 +0000
+++ ./cmd/tools/gvpack.cpp	2024-03-11 02:25:47.064388583 +0000
@@ -22,7 +22,7 @@
 
 #include "config.h"
 
-#include <getopt.h>
+//#include <getopt.h>
 #include <algorithm>
 #include <assert.h>
 #include <gvc/gvc.h>
--- ./cmd/tools/dijkstra.c_orig	2024-03-11 02:26:45.696360469 +0000
+++ ./cmd/tools/dijkstra.c	2024-03-11 02:26:54.670044035 +0000
@@ -24,7 +24,7 @@
 #include <cgraph/ingraphs.h>
 #include <cgraph/exit.h>
 #include <cgraph/unreachable.h>
-#include <getopt.h>
+//#include <getopt.h>
 
 static char *CmdName;
 static char **Files;
--- ./cmd/tools/mm2gv.c_orig	2024-03-11 02:27:41.310824360 +0000
+++ ./cmd/tools/mm2gv.c	2024-03-11 02:27:51.070059589 +0000
@@ -29,7 +29,7 @@
 #include <cgraph/agxbuf.h>
 #include <sparse/SparseMatrix.h>
 #include "matrix_market.h"
-#include <getopt.h>
+//#include <getopt.h>
 
 typedef struct {
     Agrec_t h;
--- ./cmd/tools/graphml2gv.c_orig	2024-03-11 02:28:51.610879798 +0000
+++ ./cmd/tools/graphml2gv.c	2024-03-11 02:29:01.339914523 +0000
@@ -21,7 +21,7 @@
 #include    <cgraph/gv_ctype.h>
 #include    <cgraph/stack.h>
 #include    <cgraph/unreachable.h>
-#include    <getopt.h>
+//#include    <getopt.h>
 #include    <stdbool.h>
 #include    <stdio.h>
 #include    <string.h>
--- ./cmd/edgepaint/edgepaintmain.c_orig	2024-03-11 02:30:41.952963307 +0000
+++ ./cmd/edgepaint/edgepaintmain.c	2024-03-11 02:30:52.080777271 +0000
@@ -22,7 +22,7 @@
 #include <cgraph/startswith.h>
 #include <cgraph/unreachable.h>
 #include <common/pointset.h>
-#include <getopt.h>
+//#include <getopt.h>
 
 #include <sparse/general.h>
 #include <sparse/SparseMatrix.h>
--- ./lib/gvpr/gvpr.c_orig	2024-03-11 02:35:00.505703360 +0000
+++ ./lib/gvpr/gvpr.c	2024-03-11 02:35:10.584787528 +0000
@@ -37,7 +37,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <setjmp.h>
-#include <getopt.h>
+//#include <getopt.h>
 
 #ifndef DFLT_GVPRPATH
 #define DFLT_GVPRPATH    "."