--- ./cmd/tools_orig/acyclic.c_orig	2025-09-05 01:58:06.632199019 -0500
+++ ./cmd/tools/acyclic.c	2025-09-05 01:57:58.438872210 -0500
@@ -31,7 +31,7 @@
 
 #define graphName(g) (agnameof(g))
 
-#include <getopt.h>
+//#include <getopt.h>
 
 static FILE *inFile;
 
--- ./cmd/tools_orig/bcomps.c_orig	2025-09-05 01:50:57.988093443 -0500
+++ ./cmd/tools/bcomps.c	2025-09-05 01:51:05.531059443 -0500
@@ -25,7 +25,7 @@
 #include <stdio.h>
 #include <string.h>
 #include <assert.h>
-#include <getopt.h>
+// #include <getopt.h>
 
 #include <stdlib.h>
 #include <cgraph/cgraph.h>
--- ./cmd/tools_orig/ccomps.c_orig	2025-09-05 01:58:41.611379078 -0500
+++ ./cmd/tools/ccomps.c	2025-09-05 01:58:46.810705998 -0500
@@ -23,7 +23,7 @@
 #include <cgraph/ingraphs.h>
 #include <common/render.h>
 #include <common/utils.h>
-#include <getopt.h>
+// #include <getopt.h>
 #include <stdbool.h>
 #include <stdio.h>
 #include <stdlib.h>
--- ./cmd/tools_orig/cvtgxl.c_orig	2025-09-05 01:48:26.513389296 -0500
+++ ./cmd/tools/cvtgxl.c	2025-09-05 01:47:22.501894027 -0500
@@ -20,7 +20,7 @@
 
 #include "config.h"
 
-#include <getopt.h>
+// #include <getopt.h>
 #include <stdio.h>
 #include <stdlib.h>
 
--- ./cmd/tools_orig/dijkstra.c_orig	2025-09-05 02:02:13.318134427 -0500
+++ ./cmd/tools/dijkstra.c	2025-09-05 02:02:18.639989187 -0500
@@ -22,7 +22,7 @@
 #include <math.h>
 #include <cgraph/cgraph.h>
 #include <cgraph/ingraphs.h>
-#include <getopt.h>
+// #include <getopt.h>
 #include <util/alloc.h>
 #include <util/exit.h>
 #include <util/unreachable.h>
--- ./cmd/tools_orig/gc.c_orig	2025-09-05 01:55:33.183845349 -0500
+++ ./cmd/tools/gc.c	2025-09-05 01:55:43.390625240 -0500
@@ -38,7 +38,7 @@
 
 #define ND_dfs_mark(n) (((nodeinfo_t*)(n->base.data))->dfs_mark)
 
-#include <getopt.h>
+// #include <getopt.h>
 
 #define NODES 1
 #define EDGES 2
--- ./cmd/tools_orig/gml2gv.c_orig	2025-09-05 01:52:52.392797017 -0500
+++ ./cmd/tools/gml2gv.c	2025-09-05 01:52:59.554097291 -0500
@@ -14,7 +14,7 @@
 #include <string.h>
 
 #include "openFile.h"
-#include <getopt.h>
+// #include <getopt.h>
 #include <util/agxbuf.h>
 #include <util/alloc.h>
 #include <util/debug.h>
--- ./cmd/tools_orig/graphml2gv.c_orig	2025-09-05 02:03:23.359627597 -0500
+++ ./cmd/tools/graphml2gv.c	2025-09-05 02:03:31.452919353 -0500
@@ -16,7 +16,7 @@
 
 #include    "convert.h"
 #include    <assert.h>
-#include    <getopt.h>
+// #include    <getopt.h>
 #include    <limits.h>
 #include    <stdbool.h>
 #include    <stdio.h>
--- ./cmd/tools_orig/gvcolor.c_orig	2025-09-05 01:57:01.393623667 -0500
+++ ./cmd/tools/gvcolor.c	2025-09-05 01:56:51.997381812 -0500
@@ -44,7 +44,7 @@
 
 #include <stdio.h>
 
-#include <getopt.h>
+//#include <getopt.h>
 
 double Defcolor[NC] = { 0.0, 0.0, 1.0 };	/* white */
 int Forward = 1;		/* how to propagate colors w.r.t. ranks */
--- ./cmd/tools_orig/gvgen.c_orig	2025-09-05 01:51:55.544581128 -0500
+++ ./cmd/tools/gvgen.c	2025-09-05 01:52:02.145619033 -0500
@@ -25,7 +25,7 @@
 #include <string.h>
 #include <time.h>
 #include <ctype.h>
-#include <getopt.h>
+// #include <getopt.h>
 #include "graph_generator.h"
 #include "openFile.h"
 #include <util/exit.h>
--- ./cmd/tools_orig/gvpack.cpp_orig	2025-09-05 02:01:40.034155308 -0500
+++ ./cmd/tools/gvpack.cpp	2025-09-05 02:01:45.036051816 -0500
@@ -22,7 +22,7 @@
 
 #include "config.h"
 
-#include <getopt.h>
+// #include <getopt.h>
 #include <algorithm>
 #include <cassert>
 #include <gvc/gvc.h>
--- ./cmd/tools_orig/mm2gv.c_orig	2025-09-05 02:02:49.240713271 -0500
+++ ./cmd/tools/mm2gv.c	2025-09-05 02:02:54.649510455 -0500
@@ -30,7 +30,7 @@
 #include <util/agxbuf.h>
 #include <util/unreachable.h>
 #include "matrix_market.h"
-#include <getopt.h>
+// #include <getopt.h>
 
 typedef struct {
     Agrec_t h;
--- ./cmd/tools_orig/nop.c_orig	2025-09-05 01:50:10.929591529 -0500
+++ ./cmd/tools/nop.c	2025-09-05 01:50:17.520082226 -0500
@@ -20,7 +20,7 @@
 #include <stdlib.h>
 #include <util/exit.h>
 
-#include <getopt.h>
+// #include <getopt.h>
 
 static char **Files;
 static bool chkOnly;
--- ./cmd/tools_orig/sccmap.c_orig	2025-09-05 01:59:21.208825212 -0500
+++ ./cmd/tools/sccmap.c	2025-09-05 01:59:26.046513312 -0500
@@ -32,7 +32,7 @@
 #include <cgraph/cgraph.h>
 #include <cgraph/ingraphs.h>
 
-#include <getopt.h>
+// #include <getopt.h>
 #include "openFile.h"
 #include <util/exit.h>
 #include <util/list.h>
--- ./cmd/tools_orig/tred.c_orig	2025-09-05 01:59:59.473172714 -0500
+++ ./cmd/tools/tred.c	2025-09-05 02:00:04.668141277 -0500
@@ -29,7 +29,7 @@
 #include <stdbool.h>
 #include <stdio.h>
 #include <stdlib.h>
-#include <getopt.h>
+// #include <getopt.h>
 #include <util/exit.h>
 #include <util/unreachable.h>
 
--- ./cmd/tools_orig/unflatten.c_orig	2025-09-05 02:00:36.976821261 -0500
+++ ./cmd/tools/unflatten.c	2025-09-05 02:00:41.458134966 -0500
@@ -25,7 +25,7 @@
 #include    <cgraph/cgraph.h>
 #include    <cgraph/ingraphs.h>
 
-#include <getopt.h>
+// #include <getopt.h>
 #include "openFile.h"
 #include <util/exit.h>
 #include <util/unreachable.h>
 

--- ./lib/gvpr/gvpr.c_orig	2025-09-05 02:05:06.708252658 -0500
+++ ./lib/gvpr/gvpr.c	2025-09-05 02:05:12.068129044 -0500
@@ -20,7 +20,7 @@
 #include <cgraph/cgraph.h>
 #include <cgraph/ingraphs.h>
 #include <common/globals.h>
-#include <getopt.h>
+// #include <getopt.h>
 #include <gvpr/actions.h>
 #include <gvpr/compile.h>
 #include <gvpr/gprstate.h>


--- ./cmd/tools/gvg2ml_orig.c	2025-09-05 07:48:41.000000000 -0500
+++ ./cmd/tools/gv2gml.c	2025-09-05 07:51:10.000000000 -0500
@@ -21,7 +21,7 @@
 #include <stdlib.h>
 #include <inttypes.h>
 
-#include <getopt.h>
+// #include <getopt.h>
 
 #include <cgraph/cgraph.h>
 #include <cgraph/ingraphs.h>


--- ./cmd/gvmap/gvmap_orig.c	2025-09-05 07:58:47.000000000 -0500
+++ ./cmd/gvmap/gvmap.c	2025-09-05 07:58:53.000000000 -0500
@@ -23,7 +23,7 @@
 #include <sparse/QuadTree.h>
 #include <time.h>
 #include <sparse/SparseMatrix.h>
-#include <getopt.h>
+// #include <getopt.h>
 #include <string.h>
 #include "make_map.h"
 #include <sfdpgen/spring_electrical.h>

--- ./cmd/gvmap/cluster_orig.c	2025-09-05 08:05:39.000000000 -0500
+++ ./cmd/gvmap/cluster.c	2025-09-05 08:05:47.000000000 -0500
@@ -17,7 +17,7 @@
 #include <sparse/QuadTree.h>
 #include <time.h>
 #include <sparse/SparseMatrix.h>
-#include <getopt.h>
+// #include <getopt.h>
 #include <string.h>
 #include "make_map.h"
 #include <sfdpgen/spring_electrical.h>
 
--- ./contrib/prune/prune_orig.c	2025-09-05 08:12:19.000000000 -0500
+++ ./contrib/prune/prune.c	2025-09-05 08:12:23.000000000 -0500
@@ -14,7 +14,7 @@
 #include <string.h>
 #include <ctype.h>
 
-#include <getopt.h>
+// #include <getopt.h>
 #include <cgraph/cgraph.h>
 #include <cgraph/ingraphs.h>
 #include <util/alloc.h>


--- ./cmd/edgepaint/edgepaintmain_org.c	2025-10-29 04:32:41.352806857 -0500
+++ ./cmd/edgepaint/edgepaintmain.c	2025-10-29 04:33:32.738137179 -0500
@@ -17,7 +17,8 @@
 #include <cgraph/cgraph.h>
 #include <cgraph/ingraphs.h>
 #include <common/pointset.h>
-#include <getopt.h>
+// #include <getopt.h>
+#include "../../graphviz-8.0.5-getopt_long_for_graphviz_in_AIX_v1.c"
 #include <util/agxbuf.h>
 #include <util/alloc.h>
 #include <util/debug.h>